<?php

namespace Teknisa\ATE\Controllers;

use Zeedhi\Framework\DTO\Response\Error;
use \Setforms2\Shared\ORM\DateTime;

class ATE26005CancelamentoExportacaoSAP {

	protected $connection;
	protected $environment;

	public function __construct($connection, $environment) {
		$this->connection = $connection;
		$this->environment = $environment;
    }

    public function cancel($request, $response){
    	$row = (array)$request->getRow();

    	try{
	    	$sql = "UPDATE DELIVERYM
					SET IDDELIEXPSAP = 'N'
					WHERE CDFILIAL = :CDFILIAL
					AND CDCIA      = :CDCIA
					AND (DTEMISDEL BETWEEN :DTINICIAL AND :DTFINAL)
					AND NRORG = :NRORG";

	    	$params = array(
	    		'CDFILIAL' => $row['CDFILIAL'],
	    		'CDCIA' => $row['CDCIA'],
	    		'DTINICIAL' => $row['DTINICIAL'],
	    		'DTFINAL' => $row['DTFINAL'],
	    		'NRORG' => $this->environment->getNrOrg()
	    	);

	    	$query = $this->connection->prepare($sql);
			$result = $query->execute($params);
    	} catch (\Exception $e){
    		$response->setError(new Error($e->getMessage(),500));
    	}
    }
}