<?php
namespace Teknisa\ATE\Controllers;

use \Zeedhi\Framework\Report\ReportService;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DataSource\FilterCriteria;


class Ate01800FaturamentoPorEmpresaController extends \Zeedhi\Framework\Controller\Report {

	protected $novoCodigo;
	protected $entityManager;

	public function __construct(ReportService $reportService, $novoCodigo, $entityManager, $environment){
		$this->environment = $environment;
		$this->entityManager = $entityManager;
		$this->novoCodigo = $novoCodigo;
		parent::__construct($reportService);
	}

	protected $reportMapping = array (
		'ATE01800' =>
			array (
			'strategy' => 'BIRT',
			'parameterMapping' =>
				array (
					"CDFILIAL" 		=> "CDFILIAL",
					"CDCIA" 		=> "CDCIA",
					"CDINDICE" 		=> "CDINDICE",
					"DTINICIAL" 	=> "DTINI",
					"DTFINAL" 		=> "DTFIN",
					"NRORG" 		=> "NRORG"
				),
				'reportName'
			)
	);

	public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
		$row = $request->getRow();
		$row['__report_name'] = $row['REPORTNAME'];
		$row['NRORG'] = $this->environment->getNrOrgTrab();
	}
}
