<?php
namespace Teknisa\ATE\Controllers;

use \Zeedhi\Framework\Report\ReportService;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DTO\Request\Row;

class Ate02010TotalRefeicoes extends \Zeedhi\Framework\Controller\Report {

  protected $environment;
  protected $crudService;
  protected $dataSourceManager;

  public function __construct(ReportService $reportService, $environment, $crudService, $dataSourceManager) {
    $this->crudService = $crudService;
    $this->dataSourceManager = $dataSourceManager;
    $this->environment = $environment;
    parent::__construct($reportService);
  }

  protected $reportMapping = array (
    'ATE02000' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILIAL"  => "CDFILIAL",
        "DTINICIAL" => "DATAINICIAL",
        "DTFINAL"   => "DATAFINAL",
        "NRORG"     => "NRORG"
      ),
      'reportName'
    )
  );

  public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    $row = $request->getRow();
    $row['NRORG']  = $this->environment->getNrOrgTrab();
    $row['__report_name'] = 'ATE02000';
  }
}