<?php

namespace Teknisa\ATE\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Doctrine\DBAL\Connection;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Exception;
use Zeedhi\Framework\Report\Strategy\BirtStrategy;
use Zeedhi\Framework\Report\ReportService;

class Ate02200EmissaoDeliveryController {

	protected $emissaoDeliveryService;
	protected $reportService;
    protected $environment;
	protected $MessagesProcedure;

    public function __construct($emissaoDeliveryService, $connection, $environment, $MessagesProcedure) {
        $this->emissaoDeliveryService = $emissaoDeliveryService;
        $this->connection = $connection;
        $this->environment = $environment;
        $this->MessagesProcedure = $MessagesProcedure;
    }

	public function save(DTO\Request $request, DTO\Response $response) {

        try{
	    
    	    $row = $request->getRow();
    
    	    if($row["QTSESBYPRSP"] < $row["QTSESBYUTSP"]) {
                throw new \Exception("ATE02200_QTSBYUTIL_MAIOR_QTSBY");
            }else{
            	$this->emissaoDeliveryService->saveAgrup($request,$response);
                $vrtaxa = $descnota = $descserv = $descdesv = $pedescdesv = $descfixo = $pedescfixo = $desccond = $pedesccond = $totsbyut = $totsbynut = $vrtotdesc = $vrutidesc = $iddescdesv = $iddesccond = $iddescfixo = $idincdesdesv = $idincdesfixo = $idincdescond = $totalgeralserv = $pesototserv = $cdlocafatcia = $nrdelivery = null;
                $nrseqdeliver = 0;
                $cdoperador = $this->environment->getCdOperador();
                $defineDelivery = $this->CALCULA_DELIVERYM($nrdelivery, $row['CDFILIAL'], $row['CDCIA'], $row['NRVOO'], $row['CDTRECHO'], $row['DTHRPLAVOOPV'], $row['CDAGRDECO'], $cdlocafatcia, $nrseqdeliver, $cdoperador, $pesototserv, $totalgeralserv, $vrtaxa, $descnota, $descserv, $descdesv, $pedescdesv, $descfixo, $pedescfixo, $desccond, $pedesccond, $totsbyut, $totsbynut, $vrtotdesc, $vrutidesc, $iddescdesv, $iddesccond, $iddescfixo, $idincdesdesv, $idincdesfixo, $idincdescond);
                $dataSet = new DataSet('calcula_delivery', array($defineDelivery));
                $response->addDataSet($dataSet);
            }
	    
	    } catch (\Exception $e) {
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }

	    
	}

	public function saveObs(DTO\Request $request, DTO\Response $response) {
		$this->emissaoDeliveryService->saveObs($request,$response);
	}

    public function calcDesc(DTO\Request $request, DTO\Response $response){
        $row = $request->getRow();
        $row['CDOPERADOR'] = $this->environment->getCdOperador();
        $row['NRORG'] = $this->environment->getNrOrgTrab();
        $this->CALC_DESC_PROP_DELIVERYM($row['CDFILIAL'], $row['CDCIA'], $row['NRVOO'], $row['CDTRECHO'],
            $row['DTHRPLAVOOPV'], $row['CDOPERADOR'], $row['NRORG']);
    }

    public function runProcedures(DTO\Request\Row $request, DTO\Response $response){
        try {
            $this->connection->beginTransaction();
            $row = $request->getRow();
            
            $row['CDFILIAL'] = isset($row['CDFILIAL']) ? $row['CDFILIAL'] : null;
            
            $testeAgrupDeliv = $this->emissaoDeliveryService->getAgrupDeliv($row);
            $defineDelivery = array();
            $nrseqdeliver = 0;
            $cdlocafatcia = null;
            $pesototserv = null;
            $totalgeralserv = null;
            $vrtaxa = null;
            $descnota = null;
            $descserv = null;
            $descdesv = null;
            $pedescdesv = null;
            $descfixo = null;
            $pedescfixo = null;
            $desccond = null;
            $pedesccond = null;
            $totsbyut = null;
            $totsbynut = null;
            $vrtotdesc = null;
            $vrutidesc = null;
            $iddescdesv = null;
            $iddesccond = null;
            $iddescfixo = null;
            $idincdesdesv = null;
            $idincdesfixo = null;
            $idincdescond = null;
            $nrdelivery = null;
            $row['NRORG'] = $this->environment->getNrOrgTrab();
            $nrorg = $row['NRORG'];
            $row['CDOPERADOR'] = $this->environment->getCdOperador();
            $cdoperador = $row['CDOPERADOR'];
            if ($row['ID'] == 1){
                if(gettype($row['CDAGRDECO']) == 'array'){
                    $cdagreco = $row['CDAGRDECO'][0];
                } else {
                    $cdagreco = $row['CDAGRDECO'];
                }
                $defineDelivery = $this->CALCULA_DELIVERYM($nrdelivery, $row['CDFILIAL'], $row['CDCIA'], $row['NRVOO'], $row['CDTRECHO'], $row['DTHRPLAVOOPV'], $cdagreco, $cdlocafatcia, $nrseqdeliver, $cdoperador, $pesototserv, $totalgeralserv, $vrtaxa, $descnota, $descserv, $descdesv, $pedescdesv, $descfixo, $pedescfixo, $desccond, $pedesccond, $totsbyut, $totsbynut, $vrtotdesc, $vrutidesc, $iddescdesv, $iddesccond, $iddescfixo, $idincdesdesv, $idincdesfixo, $idincdescond);
                $dataSet = new DataSet('calcula_delivery', array($defineDelivery));
                $response->addDataSet($dataSet);
            } elseif ($row['ID'] == 2) {
                $deliveries = array();
                foreach($row['CDAGRDECO'] as $cdagreco) {
                    $rowToSave = clone $row;
                    $rowToSave['CDAGRDECO'] = $cdagreco;
                    $defineDelivery = $this->CALCULA_DELIVERYM($nrdelivery, $rowToSave['CDFILIAL'], $rowToSave['CDCIA'], $rowToSave['NRVOO'], $rowToSave['CDTRECHO'], $rowToSave['DTHRPLAVOOPV'], $cdagreco, $cdlocafatcia, $nrseqdeliver, $cdoperador, $pesototserv, $totalgeralserv, $vrtaxa, $descnota, $descserv, $descdesv, $pedescdesv, $descfixo, $pedescfixo, $desccond, $pedesccond, $totsbyut, $totsbynut, $vrtotdesc, $vrutidesc, $iddescdesv, $iddesccond, $iddescfixo, $idincdesdesv, $idincdesfixo, $idincdescond);
                    $testeVraltxport = $this->emissaoDeliveryService->getVraltxport($rowToSave);
                    $testeDthrabastpv = $this->emissaoDeliveryService->getDthrabastpv($rowToSave);
                    $testeVrindice = $this->emissaoDeliveryService->getVrindice($rowToSave);
                    $testeIdtipmanualsp = $this->emissaoDeliveryService->getIdtipmanualsp($rowToSave);
                    $testeVrdescdeltmpTxdescdeltmp = $this->emissaoDeliveryService->getVrdescdeltmpTxdescdeltmp($rowToSave);

                    $vrpetxaero = $testeVraltxport[0]['VRALTXPORT'];
                    $dtemisdel = $testeDthrabastpv[0]['DTHRABASTPV'];
                    $vrcotdolar = $testeVrindice[0]['VRINDICE'];

                    if ($testeIdtipmanualsp[0]['IDTIPMANUALSP'] == 1){
                        $vrtxaeror = $defineDelivery['VRTAXA'];
                        $vrtxaerod = 0;
                    }else{
                        $vrtxaeror = 0;
                        $vrtxaerod = $defineDelivery['VRTAXA'];
                    }
                    $vrbacatx = $defineDelivery['TOTALGERALSERV'];
                    $vrdescdel = "";
                    $txdescdel = "";
                    $vrdescdesv = $defineDelivery['VRDESCDESV'];
                    $vrdesccond = $defineDelivery['VRDESCCOND'];
                    $vrdescfixo = $defineDelivery['VRDESCFIXO'];
                    $idtipnacdel = $testeIdtipmanualsp[0]['IDTIPMANUALSP'];
                    $hrprevdecpv = $testeDthrabastpv[0]['HRPREVDECPV'];
                    $cdlocafatcia = null;
                    $nmrespdel = $row['NMOPERADOR'];
                    $nrseqdeliver = 0;
                    $pxnrdelivery = null;
                    $nrdelivery = null;
                    $delivery = $this->DEFINE_DELIVERYM($rowToSave['CDFILIAL'], $rowToSave['CDCIA'], $rowToSave['NRVOO'], $rowToSave['CDTRECHO'], $rowToSave['DTHRPLAVOOPV'], $cdagreco, $vrpetxaero, $vrbacatx, $dtemisdel, $vrcotdolar, $vrtxaeror, $vrtxaerod, $vrdescdel, $txdescdel, $vrdescdesv, $vrdesccond, $vrdescfixo, $idtipnacdel, $hrprevdecpv, $cdlocafatcia, $nmrespdel, $nrseqdeliver, $pxnrdelivery, $cdoperador, $nrdelivery, $nrorg);
                    array_push($deliveries,$delivery);
                }
                $dataSet = new DataSet('deliveries_emitidos', $deliveries);
                $response->addDataSet($dataSet);
            }
            $this->connection->commit();

        } catch (\Exception $e) {
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
            $this->connection->rollback();
        }
    }

    public function DEFINE_DELIVERYM($cdfilial, $cdcia, $nrvoo, $cdtrecho, $dthrplavoopv, $cdagrdeco, $vrpetxaero, $vrbacatx, $dtemisdel, $vrcotdolar, $vrtxaeror, $vrtxaerod, $vrdescdel, $txdescdel, $vrdescdesv, $vrdesccond, $vrdescfixo, $idtipnacdel, $hrprevdecpv, $cdlocafatcia, $nmrespdel, $nrseqdeliver, $pxnrdelivery, $cdoperador, $nrdelivery, $nrorg){

        $procedure = new StoredProcedure($this->connection, 'DEFINE_DELIVERYM');
        $procedure->addParam(new Param('CDFILIAL',     Param::PARAM_INPUT, $cdfilial));
        $procedure->addParam(new Param('CDCIA',        Param::PARAM_INPUT, $cdcia));
        $procedure->addParam(new Param('NRVOO',        Param::PARAM_INPUT, $nrvoo));
        $procedure->addParam(new Param('CDTRECHO',     Param::PARAM_INPUT, $cdtrecho));
        $procedure->addParam(new Param('DTHRPLAVOOPV', Param::PARAM_INPUT, $dthrplavoopv));
        $procedure->addParam(new Param('CDAGRDECO',    Param::PARAM_INPUT, $cdagrdeco));
        $procedure->addParam(new Param('VRPETXAERO',   Param::PARAM_INPUT, $vrpetxaero));
        $procedure->addParam(new Param('VRBACATX',     Param::PARAM_INPUT, $vrbacatx));
        $procedure->addParam(new Param('DTEMISDEL',    Param::PARAM_INPUT, $dtemisdel));
        $procedure->addParam(new Param('VRCOTDOLAR',   Param::PARAM_INPUT, $vrcotdolar));
        $procedure->addParam(new Param('VRTXAEROR',    Param::PARAM_INPUT, $vrtxaeror));
        $procedure->addParam(new Param('VRTXAEROD',    Param::PARAM_INPUT, $vrtxaerod));
        $procedure->addParam(new Param('VRDESCDEL',    Param::PARAM_INPUT, $vrdescdel));
        $procedure->addParam(new Param('TXDESCDEL',    Param::PARAM_INPUT, $txdescdel));
        $procedure->addParam(new Param('VRDESCDESV',   Param::PARAM_INPUT, $vrdescdesv));
        $procedure->addParam(new Param('VRDESCCOND',   Param::PARAM_INPUT, $vrdesccond));
        $procedure->addParam(new Param('VRDESCFIXO',   Param::PARAM_INPUT, $vrdescfixo));
        $procedure->addParam(new Param('IDTIPNACDEL',  Param::PARAM_INPUT, $idtipnacdel));
        $procedure->addParam(new Param('HRPREVDECPV',  Param::PARAM_INPUT, $hrprevdecpv));
        $procedure->addParam(new Param('CDLOCAFATCIA', Param::PARAM_INPUT, null));
        $procedure->addParam(new Param('NMRESPDEL',    Param::PARAM_INPUT, $nmrespdel));
        $procedure->addParam(new Param('NRSEQDELIVER', Param::PARAM_INPUT, $nrseqdeliver));
        $procedure->addParam(new Param('PXNRDELIVERY', Param::PARAM_INPUT, $pxnrdelivery));
        $procedure->addParam(new Param('CDOPERADOR',   Param::PARAM_INPUT, $cdoperador));
        $procedure->addParam(new Param('NRDELIVERY',   Param::PARAM_OUTPUT ,null,null,20));
        $procedure->addParam(new Param('NRORG',        Param::PARAM_INPUT, $nrorg));
        $result = $procedure->execute();
        return $result['NRDELIVERY'];

    }

    public function CALC_DESC_PROP_DELIVERYM($cdfilial, $cdcia, $nrvoo, $cdtrecho, $dthrplavoopv, $cdoperador, $nrorg) {
        $procedure = new StoredProcedure($this->connection, 'CALC_DESC_PROP_DELIVERYM');
        $procedure->addParam(new Param('CDFILIAL',      Param::PARAM_INPUT, $cdfilial));
        $procedure->addParam(new Param('CDCIA',         Param::PARAM_INPUT, $cdcia));
        $procedure->addParam(new Param('NRVOO',         Param::PARAM_INPUT, $nrvoo));
        $procedure->addParam(new Param('CDTRECHO',      Param::PARAM_INPUT, $cdtrecho));
        $procedure->addParam(new Param('DTHRPLAVOOPV',  Param::PARAM_INPUT, $dthrplavoopv));
        $procedure->addParam(new Param('CDOPERADOR',    Param::PARAM_INPUT, $cdoperador));
        $procedure->addParam(new Param('NRORG',         Param::PARAM_INPUT, $nrorg));
    }

    public function CALCULA_DELIVERYM($nrdelivery, $cdfilial, $cdcia, $nrvoo, $cdtrecho, $dthrplavoopv, $cdagrdeco, $cdlocafatcia, $nrseqdeliver, $cdoperador){
        $procedure = new StoredProcedure($this->connection, 'CALCULA_DELIVERYM');
        $procedure->addParam(new Param('NRDELIVERY',         Param::PARAM_INPUT, null));
        $procedure->addParam(new Param('CDFILIAL',           Param::PARAM_INPUT, $cdfilial));
        $procedure->addParam(new Param('CDCIA',              Param::PARAM_INPUT, $cdcia));
        $procedure->addParam(new Param('NRVOO',              Param::PARAM_INPUT, $nrvoo));
        $procedure->addParam(new Param('CDTRECHO',           Param::PARAM_INPUT, $cdtrecho));
        $procedure->addParam(new Param('DTHRPLAVOOPV',       Param::PARAM_INPUT, $dthrplavoopv));
        $procedure->addParam(new Param('CDAGRDECO',          Param::PARAM_INPUT, $cdagrdeco));
        $procedure->addParam(new Param('CDLOCAFATCIA',       Param::PARAM_INPUT, $cdlocafatcia));
        $procedure->addParam(new Param('NRSEQDELIVER',       Param::PARAM_INPUT, $nrseqdeliver));
        $procedure->addParam(new Param('CDOPERADOR',         Param::PARAM_INPUT, $cdoperador));
        $procedure->addParam(new Param('PESOTOTSERV',        Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('TOTALGERALSERV',     Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('VRTAXA',             Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('DESCNOTA',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('DESCSERV',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('DESCDESV',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('PEDESCDESV',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('DESCFIXO',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('PEDESCFIXO',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('DESCCOND',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('PEDESCCOND',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('TOTSBYUT',           Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('TOTSBYNUT',          Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('VRTOTDESC',          Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('VRUTIDESC',          Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDDESCDESV',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDDESCCOND',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDDESCFIXO',         Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDINCDESDESV',       Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDINCDESFIXO',       Param::PARAM_OUTPUT, null,null, 20));
        $procedure->addParam(new Param('IDINCDESCOND',       Param::PARAM_OUTPUT, null,null, 20));

        $result = $procedure->execute();

        $arrayResult = array();
        $arrayResult['PESOTOTSERV'] = $result['PESOTOTSERV'];
        $arrayResult['TOTALGERALSERV'] = $result['TOTALGERALSERV'];
        $arrayResult['VRTAXA'] = $result['VRTAXA'];
        $arrayResult['DESCNOTA'] = $result['DESCNOTA'];
        $arrayResult['DESCSERV'] = $result['DESCSERV'];
        $arrayResult['VRDESCDESV'] = $result['DESCDESV'];
        $arrayResult['PEDESCDESV'] = $result['PEDESCDESV'];
        $arrayResult['VRDESCFIXO'] = $result['DESCFIXO'];
        $arrayResult['PEDESCFIXO'] = $result['PEDESCFIXO'];
        $arrayResult['VRDESCCOND'] = $result['DESCCOND'];
        $arrayResult['PEDESCCOND'] = $result['PEDESCCOND'];
        $arrayResult['TOTSBYUT'] = $result['TOTSBYUT'];
        $arrayResult['TOTSBYNUT'] = $result['TOTSBYNUT'];
        $arrayResult['VRTOTDESC'] = $result['VRTOTDESC'];
        $arrayResult['VRUTIDESC'] = $result['VRUTIDESC'];
        $arrayResult['IDDESCDESV'] = $result['IDDESCDESV'];
        $arrayResult['IDDESCCOND'] = $result['IDDESCCOND'];
        $arrayResult['IDDESCFIXO'] = $result['IDDESCFIXO'];
        $arrayResult['IDINCDESDESV'] = $result['IDINCDESDESV'];
        $arrayResult['IDINCDESFIXO'] = $result['IDINCDESFIXO'];
        $arrayResult['IDINCDESCOND'] = $result['IDINCDESCOND'];
        return $arrayResult;
    }
}