<?php

namespace Teknisa\ATE\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use \Teknisa\ATE\Utilities\MessagesProcedure;
use Zeedhi\Framework\DTO\Response\Error;
use Doctrine\DBAL\Connection;

class GerarRetroBillController extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $dataSourceName;
    protected $parameterBagColumns = array();
    protected $GerarRetroBillProcedure;
    protected $DeleteRetroBillProcedure;
    protected $GerarPlanoVooRetroBillProcedure;
    protected $DescontoRetrobillProcedure;
    protected $MessagesProcedure;

    public function __construct($crudService, $parameterBag,  $environment, $dataSourceManager, $GerarRetroBillProcedure, $DeleteRetroBillProcedure, $GerarPlanoVooRetroBillProcedure, $DescontoRetrobillProcedure, $MessagesProcedure) {
        $this->crudService  = $crudService;
        $this->parameterBag = $parameterBag;
        $this->environment  = $environment;
        $this->dataSourceManager = $dataSourceManager;
        $this->GerarRetroBillProcedure = $GerarRetroBillProcedure;
        $this->DeleteRetroBillProcedure = $DeleteRetroBillProcedure;
        $this->GerarPlanoVooRetroBillProcedure = $GerarPlanoVooRetroBillProcedure;
        $this->DescontoRetrobillProcedure = $DescontoRetrobillProcedure;
        $this->MessagesProcedure = $MessagesProcedure;
    }

    public function executeProcedureRetroBill(DTO\Request\DataSet $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows();
        $row = $row[0];
        $row['CDOPERADOR'] = $this->environment->getCdOperador();
        $row['NRORG']  = $this->environment->getNrOrgTrab();

        try {   
            $this->GerarRetroBillProcedure->executeProcedure($row['CDFILIAL'], $row['CDCIA'], $row['DTINICIAL'],
                $row['DTFINAL'],$row['CDOPERADOR'],$row['NRORG'], $response);
        } catch (\Exception $e) {
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }
    }

    public function executeProcedurePlanoVooRetroBill(DTO\Request\DataSet $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows();
        $row = $row[0];

        $row['NRORG']  = $this->environment->getNrOrgTrab();
        $row['CDOPERADOR'] = $this->environment->getCdOperador();

        try {   
            $this->GerarPlanoVooRetroBillProcedure->executeProcedure($row['CDFILIAL'], $row['NRRETROBILL'], $row['DTHRPLAVOOPV'],
                $row['CDOPERADOR'],$row['NRORG'], $response);
        } catch (\Exception $e) {
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }
    }

    public function deleteRetroBill(DTO\Request\DataSet $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows();
        $row = $row[0];

        try {   
            $this->DeleteRetroBillProcedure->deleteProcedure($row['CDFILIAL'], $row['NRRETROBILL']);
        } catch (\Exception $e) {
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }
    }

    public function executeProcedureDescontoRetroBill(DTO\Request\DataSet $request, DTO\Response $response){
        $row = $request->getDataSet()->getRows();
        $row = $row[0];
        $row['CDOPERADOR'] = $this->environment->getCdOperador();

        try {   
            $this->DescontoRetrobillProcedure->descontoProcedure($row['CDFILIAL'], $row['NRRETROBILL'], $row['IDTIPO'], $row['DESCONTO'], $row['CDOPERADOR'], $row['NRORG']);
        } catch (\Exception $e) {
            $response->setError(new Error($this->MessagesProcedure->cleanMessage($e->getMessage()), 500));
        }
    }
}