<?php
namespace Teknisa\ATE\Controllers;

use Zeedhi\Framework\Report\ReportService;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DTO\Request\Row;

class RelatorioQuantidadePassageirosClasse extends \Zeedhi\Framework\Controller\Report {

    protected $birtStrategy;
    protected $environment;

    public function __construct(ReportService $reportService, $environment, $birtStrategy) {
        $this->birtStrategy = $birtStrategy;
        $this->environment = $environment;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'ATE00002' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                "CDFILIAL"     =>"CDFILIAL",
                "CDCIA"        =>"CDCIA",
                "CDCLASSE"     =>"CDCLASSE",
                "DTINICIAL"    =>"DTINICIAL",
                "DTFINAL"      =>"DTFINAL",
                "NRORG"        =>"NRORG",
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row['NRORG']  = $this->environment->getNrOrgTrab();
        $row['__report_name'] = $row['REPORTNAME'];
        $this->birtStrategy->setReportFormat($row['REPORTFORMAT']);
    }

}
