<?php
namespace Teknisa\ATE\Controllers;

use \Zeedhi\Framework\Report\ReportService;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DTO\Request\Row;

class RetrobillViewer extends \Zeedhi\Framework\Controller\Report {

    protected $environment;
    protected $crudService;
    protected $dataSourceManager;

    public function __construct(ReportService $reportService, $environment, $crudService, $dataSourceManager) {
        $this->crudService = $crudService;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'ATE43000' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL"    => "P_CDFILIAL",
              "NRORG"       => "P_NRORG",
              "NRRETROBILL" => "P_NRGERACAO"
            ),
            'reportName'
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row['__report_name'] = 'ATE43000';
    }
}