<?php
namespace Teknisa\ATE\Services;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class GerarPlanoVooProcedureCancelado extends StoredProcedure {

	public function __construct(Connection $connection, $procedureName = 'CANCELA_PLANO_VOOM') {
		parent::__construct($connection, $procedureName);
	}

	public function executeProcedure($P_CDFILIAL, $P_CDCIA, $P_NRVOO, $P_CDTRECHO, $P_DTHRPLAVOOPV, $P_TIPOOPER, $environment) {

		$this->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $P_CDFILIAL));
		$this->addParam(new Param('P_CDCIA', Param::PARAM_INPUT, $P_CDCIA));
		$this->addParam(new Param('P_NRVOO', Param::PARAM_INPUT, $P_NRVOO));
		$this->addParam(new Param('P_CDTRECHO', Param::PARAM_INPUT, $P_CDTRECHO));
		$this->addParam(new Param('P_DTHRPLAVOOPV', Param::PARAM_INPUT, $P_DTHRPLAVOOPV));
		$this->addParam(new Param('P_TIPOOPER', Param::PARAM_INPUT, $P_TIPOOPER));
        $this->addParam(new Param('P_CDOPERADOR',   Param::PARAM_INPUT, $environment->getCdOperador()));
        $this->addParam(new Param('P_NRORG',        Param::PARAM_INPUT, $environment->getNrOrg()));

	    $this->execute();
		// clear params
		$this->params = array();

	}
}